package com.sun.net.httpserver;

import jdk.Exported;

@Exported
public abstract class Authenticator
{
    public Authenticator() {
    }
    
    public abstract Authenticator.Result authenticate(HttpExchange p0);
    
    public abstract static class Result
    {
    }
    
    @Exported
    public static class Failure extends Authenticator.Result
    {
        private int responseCode;
        
        public Failure(int responseCode) {
            this.responseCode = responseCode;
        }
        
        public int getResponseCode() {
            return this.responseCode;
        }
    }
    
    @Exported
    public static class Success extends Authenticator.Result
    {
        private HttpPrincipal principal;
        
        public Success(HttpPrincipal principal) {
            this.principal = principal;
        }
        
        public HttpPrincipal getPrincipal() {
            return this.principal;
        }
    }
    
    @Exported
    public static class Retry extends Authenticator.Result
    {
        private int responseCode;
        
        public Retry(int responseCode) {
            this.responseCode = responseCode;
        }
        
        public int getResponseCode() {
            return this.responseCode;
        }
    }
}
